<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "dashboard".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Dashboard".
 *
 * Columns in table "dashboard" available as properties of the model,
 * and there are no model relations.
 *
 * @property integer $id
 * @property string $name
 * @property string $description
 * @property string $key_name
 * @property string $query
 * @property string $date_added
 * @property string $date_updated
 * @property string $engine
 *
 */
abstract class BaseDashboard extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'dashboard';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Dashboard|Dashboards', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name, key_name, date_added, engine', 'required'),
            array('name, key_name', 'length', 'max'=>50),
            array('engine', 'length', 'max'=>10),
            array('description, query, date_updated', 'safe'),
            array('description, query, date_updated', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, description, key_name, query, date_added, date_updated, engine', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'description' => Yii::t('app', 'Description'),
            'key_name' => Yii::t('app', 'Key Name'),
            'query' => Yii::t('app', 'Query'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'engine' => Yii::t('app', 'Engine'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('description', $this->description, true);
        $criteria->compare('key_name', $this->key_name, true);
        $criteria->compare('query', $this->query, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('engine', $this->engine, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
